package de.proton.MessProgrammvonHarald;

import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Enumeration;

public class VC820minimalZwei implements Runnable
{
    static CommPortIdentifier portId;

    static Enumeration portList;

    int numBytes;

    InputStream inputStream;
    OutputStream outputStream;

    SerialPort serialPort;
    Thread readThread;

    public static void main(String[] args) throws Exception
    {
        portList = CommPortIdentifier.getPortIdentifiers();
        System.out.println("Programm gestartet... Lese vom COM-Port");
        while (portList.hasMoreElements())
        {
            portId = (CommPortIdentifier) portList.nextElement();
            if (portId.getPortType() == CommPortIdentifier.PORT_SERIAL)
            {
                if (portId.getName().equals("COM5"))
                {
                    new VC820minimalZwei();
                }
            }
        }
    }

    public VC820minimalZwei()
    {
        try
        {
            serialPort = (SerialPort) portId.open("Com5", 2000);
            inputStream = serialPort.getInputStream();
            outputStream = serialPort.getOutputStream();

            serialPort.notifyOnDataAvailable(true);
            serialPort.setSerialPortParams(2400, SerialPort.DATABITS_8, SerialPort.STOPBITS_1, SerialPort.PARITY_NONE);
            serialPort.setDTR(true);
            serialPort.setRTS(false);
        } catch (Exception e)
        {
            e.printStackTrace();
        }

        readThread = new Thread(this);
        readThread.start();
    }

    public synchronized void run()
    {
        byte[] readBuffer = new byte[14];
        byte[] miniBuffer = new byte[1];
    
        Datagramm data;
        while (true)
        {
            try
            {
                Thread.sleep(1000);
            } catch (InterruptedException e1)
            {
                e1.printStackTrace();
            }

            try
            {
                while (inputStream.available() > 0)
                {
                    numBytes = inputStream.read(miniBuffer);
                    
                    // Check ob Highnibble des ersten Bytes den Wert 1 hat
                    // Dies ist die Datagramm-Nummer, die 1 bis 14 sein kann
                    // Nur wenn diese den Wert 1 hat, beginnt das Datagrammm
                    // von vorne und soll gelesen werden.
                    
                    if ((miniBuffer[0] & 0xF0)==16)
                    {
                        System.out.println(miniBuffer[0]+"Bit Null im 1.Highbyte gesetzt. Start Buffer zu fllen");
                        
                        // restliche 13 Datagramme lesen
                        numBytes = inputStream.read(readBuffer,1,13);                        
                    }
                    // 1. Datagramm an Stelle 0 schon gelesen
                    readBuffer[0] = miniBuffer[0];
                                                            
                    for (int i = 0; i < 14; i++)
                    {
                        System.out.print((int) readBuffer[i] + " ");
                    }
                    
                    data = new Datagramm(readBuffer);
                    System.out.println();
                    System.out.println("Auto: " + data.Auto);
                    System.out.println("Beep: " + data.Beep);
                    System.out.println(data.RealValue);
                }
            } catch (IOException e)
            {
                e.printStackTrace();
            }
        }
    }
}
